##### DISCLAIMER (Please do not edit) ############

# The present routine as been assembled by JF Doussin (September 2017)
# in the framework of the Eurochamp-2020 Infrastructure activity funded 
# by European Union's Horizon 2020 research and innovation programme 
#under grant agreement No 730997".

# it aims at producing a continuous long EDF file from a serie of EDF files of the same type 
# (eg. 7 seven identical files recorded along a week can be "glued" together to make a single one covering 7 days". 

# see description of the EDF format at http:\\http://www.eurochamp.org/Data.aspx. 

# The files have to be located in the same directory  and a list file must be provided.
# The list file is an ASCII file specifying in one color the list of file to be "glued" together (an exemple is provided). 
# the list file must be available in the same directory as the datafiles themselves. 

# User input are required only at lines 24, 28 and 32

######################## Empty memory ############################

rm(list = ls(all = TRUE))

# !!!!!!!!!!!!! WARNIG ! USER INPUT REQUESTED !!!!!!!!!!!!!!!!!!!!
# ------ Indicate  data directories -------------
indir<-"C:/Users/DoussinJF/Documents/JFD/R/Eurochamp-2020/GlueEDF/"

# !!!!!!!!!!!!! WARNIG ! USER INPUT REQUESTED !!!!!!!!!!!!!!!!!!!!
# ------ Indicate the list file name -------------
infile <- "list.lst"

# !!!!!!!!!!!!! WARNIG ! USER INPUT REQUESTED !!!!!!!!!!!!!!!!!!!!
# ------ Indicate the output filename  -------------
outfile<-"DATA_NOx_1_20171106_0857-r"


################### Open the Output file ###################
infile<-paste(indir,infile,sep="")
outfile<-paste(indir,outfile,".edf",sep="")
fileConn<-file(outfile, open="wt")


################## Read the list of files ##################
con <- file(infile, open = "r")
list_file <- readLines(con)
close(con)

############## Counting the file in file_list ##############
Count<-0

for (file in list_file){
     Count<- Count+1
     ####### name of the currently treated edf file ########
     edf_file<-paste(indir,file,sep="")
    
    if (Count < 2) {

      con <- file(edf_file, open = "r")
      lines_edf <- readLines(con)
      close(con)
      
      border<- grep("&",lines_edf)
      lines_edf<-lines_edf[1:border]
      
      writeLines(lines_edf, fileConn)
      
      
      ############## Look for the date ##############
      unit<-lines_edf[which(substr(lines_edf,1,8)=="UNITS(0)")]
      date_ini<-unlist((strsplit(unit," ")))[3]
      heure_ini<-unlist((strsplit(unit," ")))[4]
     
      #Initial time definition
      Initial_time<-as.POSIXct(paste(date_ini,heure_ini,sep=" "),tz="UTC")
      
    }
     
     con <- file(edf_file, open = "r")
     lines_edf <- readLines(con)
     close(con)
     
     ####### Replace comma with dot if needed #######
     write.table(gsub(',','.',lines_edf),append=F,quote=F,sep=" ",file='tmp',col.names=F,row.names=F)
     
     
     ####### Find "NUMBER OF COLUMNS=" #######
     nbcol<-lines_edf[which(substr(lines_edf,1,17)=="NUMBER OF COLUMNS")]
     #recupration du nombre de colonne
     nbcol<-as.integer(unlist(strsplit(nbcol,"="))[2])
     
     ######## Find UNITS(0) #######
     unit<-lines_edf[which(substr(lines_edf,1,8)=="UNITS(0)")]
     #recupration date et heure  T0
     date_ini<-unlist((strsplit(unit," ")))[3]
     heure_ini<-unlist((strsplit(unit," ")))[4]
     
     #---------- Read the data from a line starting with "&" ------
     # (careful all the lines below this point should contain data )
     data<-read.table('tmp',skip=which(substr(lines_edf,1,1)=="&"))
     
     ####################### Define the time #####################
     sec_initial_time<-as.POSIXct(paste(date_ini,heure_ini,sep=" "),tz="UTC")
     deltatime<- sec_initial_time - Initial_time
     delta_time<-as.numeric(deltatime, units="secs")
     time<-data[,1]
     time<-time+delta_time
     data[,1]<- time
     
     attach(data)
     
     data_ordered_by_time <- data[order(data(,V1), decreasing=FALSE)]
     
     write.table(data ,file=fileConn,col.names=F,row.names=F)
     rm(data)
}
close(fileConn)


